#define _WIN32_WINDOWS 0x410
#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "msgpack.h"
#include "pdTabletTransfer.h"
#include <wintab.h>
#define PACKETDATA (PK_CURSOR | PK_X | PK_Y | PK_BUTTONS | PK_NORMAL_PRESSURE | PK_ORIENTATION)
#define PACKETMODE 0
#include <pktdef.h>
#include "wintabletapp.h"
#ifdef USE_X_LIB
#include <wintabx.h>
#endif
#define NPACKETQSIZE 32    /* set as needed for your app. */

HWND DoCreateStatusBar(HWND hwndParent, 
                       int nStatusID, 
                       HINSTANCE hinst, 
                       int nParts);

HANDLE hInst, 
       pdTransferMutex = NULL,
       pdTransferFileMap, 
       pdProcHandle = NULL;
int pdProcId = 0;
PACKET localPacketBuf[NPACKETQSIZE];
HWND sbhWnd;
static HCTX hTab = NULL;
pdTabletTransferData *pdTabletData = NULL;

int tokenizeCommandLineString(char *clString, char **tokens) {
    int i, charCount = 0;
    int tokCount= 0;
    int quoteOpen = 0;

    for (i = 0; i < (int)strlen(clString); i++) {
        if (clString[i] == '"') {
            quoteOpen = !quoteOpen;
        }
        else if (clString[i] == ' ' && !quoteOpen) {
            tokens[tokCount][charCount] = 0;
            tokCount++;
            charCount = 0;
        }
        else {
            tokens[tokCount][charCount] = clString[i];
            charCount++;
        }
    }
    tokens[tokCount][charCount] = 0;
    tokCount++;
    return tokCount;
}

int PASCAL WinMain(HANDLE hInstance, 
                   HANDLE hPrevInstance, 
                   LPSTR lpCmdLine, 
                   int nCmdShow) {
    MSG msg;
    int i, argc;
    char *argv[128];

    for (i = 0; i < 128; i++) {
        argv[i] = (char *)malloc(128 * sizeof(char));
    }
    GetModuleFileName(NULL, argv[0], 128);
    argc = tokenizeCommandLineString(lpCmdLine, argv + 1) + 1;
    if (argc > 1) {
        pdTransferFileMap = OpenFileMapping(FILE_MAP_ALL_ACCESS,
                                            0,
                                            argv[2]);
        pdTabletData = (pdTabletTransferData *)MapViewOfFile(pdTransferFileMap,
                                                             FILE_MAP_ALL_ACCESS,
                                                             0,
                                                             0,
                                                             sizeof(pdTabletTransferData));
    }
    if (argc > 2) {
        pdTransferMutex = OpenMutex(MUTEX_ALL_ACCESS, 0, argv[3]);
    }
    if (argc > 3) {
        char str[128];
        
        pdProcId = atol(argv[4]);
        pdProcHandle = OpenProcess(PROCESS_ALL_ACCESS,
                                   FALSE, 
                                   pdProcId);
        sprintf(str, "%s", argv[4]);
    }
    for (i = 0; i < 128; i++) {
        free(argv[i]);
    }
    if (!hPrevInstance)
    if (!InitApplication(hInstance))
        return (FALSE);
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);
    while (GetMessage(&msg,
                      NULL,
                      0,
                      0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    UnmapViewOfFile(pdTabletData);
    CloseHandle(pdTransferFileMap);
    CloseHandle(pdTransferMutex);
    return (msg.wParam);
}

BOOL InitApplication(HANDLE hInstance) {
    WNDCLASS  wc;

    wc.style = 0;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_APPWORKSPACE + 1);
    wc.lpszMenuName =  "SysPressMenu";
    wc.lpszClassName = "PdTabletWClass";
    return (RegisterClass(&wc));
}

BOOL InitInstance(HANDLE hInstance, int nCmdShow) {
    HWND hWnd; 
    char buf[50];
    
    hInst = hInstance;
    if (!WTInfo(0, 0, NULL)) {
        MessageBox(NULL, 
                   "WinTab Services Not Available.",
                   "WinTab",
                   MB_OK | MB_ICONHAND);
        return FALSE;
    }
    wsprintf(buf, "WinTablet", hInst);
    hWnd = CreateWindowEx(WS_EX_TOPMOST,
                          "PdTabletWClass",
                          buf,
                          WS_BORDER | WS_SYSMENU,
                          CW_USEDEFAULT,
                          CW_USEDEFAULT,
                          254,
                          255,
                          NULL,
                          NULL,
                          hInstance,
                          NULL);
    sbhWnd = DoCreateStatusBar(hWnd, 0, hInstance, 5);
    if (!hWnd)
        return (FALSE);
    ShowWindow(sbhWnd, nCmdShow);
    UpdateWindow(sbhWnd);
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return (TRUE);
}

HCTX static NEAR TabletInit(HWND hWnd) {
    LOGCONTEXT lcMine;

    WTInfo(WTI_DEFCONTEXT, 0, &lcMine);
    wsprintf(lcMine.lcName, "PrsTest Digitizing %x", hInst);
    lcMine.lcOptions |= CXO_MESSAGES;
    lcMine.lcPktData = PACKETDATA;
    lcMine.lcPktMode = PACKETMODE;
    lcMine.lcMoveMask = PACKETDATA;
    lcMine.lcBtnUpMask = lcMine.lcBtnDnMask;
    lcMine.lcOutOrgX = lcMine.lcOutOrgY = 0;
    lcMine.lcOutExtX = 1024;
    lcMine.lcOutExtY = 1024;
    return WTOpen(hWnd, &lcMine, TRUE);
}

static UINT wActiveCsr = 0,  wOldCsr = (UINT) - 1;
static BYTE wPrsBtn;
static UINT prsYesBtnOrg, prsYesBtnExt, prsNoBtnOrg, prsNoBtnExt;

void PrsInit(void) {
    AXIS np;
    LOGCONTEXT lc;
    BYTE logBtns[32];
    UINT btnMarks[2];
    UINT size;

    wPrsBtn = (BYTE)-1;
    WTInfo(WTI_CURSORS + wActiveCsr, CSR_NPBUTTON, &wPrsBtn);
    size = WTInfo(WTI_CURSORS + wActiveCsr, CSR_BUTTONMAP, &logBtns);
    if ((UINT)wPrsBtn < size)
        wPrsBtn = logBtns[wPrsBtn];
    WTGet(hTab, &lc);
    WTInfo(WTI_DEVICES + lc.lcDevice, DVC_NPRESSURE, &np);
    prsNoBtnOrg = (UINT)np.axMin;
    prsNoBtnExt = (UINT)np.axMax - (UINT)np.axMin;
    btnMarks[1] = 0; /* default if info item not present. */
    WTInfo(WTI_CURSORS + wActiveCsr, CSR_NPBTNMARKS, btnMarks);
    prsYesBtnOrg = btnMarks[1];
    prsYesBtnExt = (UINT)np.axMax - btnMarks[1];
}

UINT PrsAdjust(PACKET p) {
    UINT wResult;

    wActiveCsr = p.pkCursor;
    if (wActiveCsr != wOldCsr) {
        PrsInit();
        wOldCsr = wActiveCsr;
    }
    if (p.pkButtons & (1 << wPrsBtn)) {
        wResult = p.pkNormalPressure - prsYesBtnOrg;
        wResult = MulDiv(wResult, 255, prsYesBtnExt);
    }
    else {
        wResult = p.pkNormalPressure - prsNoBtnOrg;
        wResult = MulDiv(wResult, 255, prsNoBtnExt);
    }
    return wResult;
}

HWND DoCreateStatusBar(HWND hwndParent, 
                       int nStatusID, 
                       HINSTANCE hinst, 
                       int nParts) {
    HWND hwndStatus;
    RECT rcClient;
    HLOCAL hloc;
    LPINT lpParts;
    int i, nWidth;

    InitCommonControls();
    hwndStatus = CreateWindowEx(0,                 // no extended styles
                                STATUSCLASSNAME,   // name of status bar class
                                (LPCTSTR) NULL,    // no text when first created
                                WS_CHILD,          // creates a child window
                                0, 0, 0, 0,        // ignores size and position
                                hwndParent,        // handle to parent window
                                (HMENU) nStatusID, // child window identifier
                                hinst,             // handle to application instance
                                NULL);              // no window creation data
    GetClientRect(hwndParent, &rcClient);
    hloc = LocalAlloc(LHND, sizeof(int) * nParts);
    lpParts = LocalLock(hloc);
    nWidth = rcClient.right / nParts;
    for (i = 0; i < nParts; i++) { 
       lpParts[i] = nWidth * (i + 1);
    }
    SendMessage(hwndStatus,
                SB_SETPARTS, 
                (WPARAM)nParts,
                (LPARAM)lpParts);
    LocalUnlock(hloc);
    LocalFree(hloc);
    return hwndStatus;
}  

LRESULT FAR PASCAL MainWndProc(HWND hWnd,
                               unsigned message,
                               WPARAM wParam,
                               LPARAM lParam) {
    static POINT ptOrg;
    static int prsOld, prsNew;
    static DWORD btnOld, btnNew;
    static int lastX, lastY;
    static unsigned int lastPressure, lastCursor, lastButtons;
    static char str[4096];
    HDC hDC;
    BOOL fHandled = TRUE;
    LRESULT lResult = 0L;
    PACKET pkt;
    HBRUSH hBrush;
    HPEN hPen;
    POINT points[2];
    static COLORREF bgColor;
    static int firstTime = 1;
    int pdProcExitCode;

    if (pdProcHandle) {
        GetExitCodeProcess(pdProcHandle, &pdProcExitCode);
        if (pdProcExitCode != STILL_ACTIVE) {
            exit(0);
        }
    }
    SetTimer(hWnd, 1, 500, NULL);
    switch (message) {
      case WM_CREATE:
        hTab = TabletInit(hWnd);
        if (!hTab) {
            MessageBox(NULL,
                       " Could Not Open Tablet Context.", "WinTab",
                       MB_OK | MB_ICONHAND);
            SendMessage(hWnd, WM_DESTROY, 0, 0L);
        }
        break;
        case WM_SIZE:
        case WM_MOVE:
            ptOrg.x = ptOrg.y = 0;
            ClientToScreen(hWnd, &ptOrg);
            InvalidateRect(hWnd, NULL, TRUE);
            break;
        case WM_ACTIVATE:
            if (hTab && GET_WM_ACTIVATE_STATE(wParam, lParam))
                WTOverlap(hTab, TRUE);
            break;
        case WT_PACKET:
            if (WTPacket((HCTX)lParam, wParam, &pkt)) {
                int screenX, screenY;

                if (lastX != pkt.pkX || \
                    lastY != pkt.pkY || \
                    lastPressure != pkt.pkNormalPressure || \
                    lastCursor != pkt.pkCursor || \
                    lastButtons != pkt.pkButtons) {
                    hDC = GetDC(hWnd);
                    if (firstTime) {
                        bgColor = GetPixel(hDC, 1, 1);
                        firstTime = 0;
                    }
                    if (lastX != pkt.pkX || lastY != pkt.pkY) {
                        screenX = (int)((float)lastX / 4.096);
                        screenY = (int)(200 - ((float)lastY / 5.12));
                        hBrush = CreateSolidBrush(bgColor);
                        hPen = CreatePen(PS_SOLID, 1, bgColor);
                        SelectObject(hDC, hBrush);
                        SelectObject(hDC, hPen);
                        points[0].x = 0;
                        points[0].y = screenY - 1;
                        points[1].x = 254;
                        points[1].y = screenY - 1;
                        Polyline(hDC, points, 2);
                        points[0].x = screenX - 1;
                        points[0].y = 0;
                        points[1].x = screenX - 1;
                        points[1].y = 205;
                        Polyline(hDC, points, 2);
                        RoundRect(hDC, 
                                  screenX - 6,
                                  screenY - 6,
                                  screenX + 6,
                                  screenY + 6,
                                  12,
                                  12);
                        DeleteObject(hBrush);
                        DeleteObject(hPen);
                    }
                    hBrush = CreateSolidBrush(RGB((float)pkt.pkNormalPressure / 1024 * 255,
                                                  (float)pkt.pkNormalPressure / 1024 * 255,
                                                  (float)pkt.pkNormalPressure / 1024 * 255));
                    hPen = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
                    SelectObject(hDC, hBrush);
                    SelectObject(hDC, hPen);
                    screenX = (int)((float)pkt.pkX / 4.096);
                    screenY = (int)(200 - ((float)pkt.pkY / 5.12));
                    points[0].x = 0;
                    points[0].y = screenY - 1;
                    points[1].x = 254;
                    points[1].y = screenY - 1;
                    Polyline(hDC, points, 2);
                    points[0].x = screenX - 1;
                    points[0].y = 0;
                    points[1].x = screenX - 1;
                    points[1].y = 205;
                    Polyline(hDC, points, 2);
                    RoundRect(hDC, 
                              screenX - 6,
                              screenY - 6,
                              screenX + 6,
                              screenY + 6,
                              12,
                              12); 
                    DeleteObject(hBrush); 
                    DeleteObject(hPen);
                    ReleaseDC(hWnd, hDC);
                    sprintf(str, " %d", pkt.pkX);
                    SendMessage(sbhWnd, SB_SETTEXT, 0, str);
                    sprintf(str, " %d", 1023 - pkt.pkY);
                    SendMessage(sbhWnd, SB_SETTEXT, 1, str);
                    sprintf(str, " %d", pkt.pkNormalPressure);
                    SendMessage(sbhWnd, SB_SETTEXT, 2, str);
                    sprintf(str, " %d", pkt.pkCursor);
                    SendMessage(sbhWnd, SB_SETTEXT, 3, str);
                    sprintf(str, " %d", pkt.pkButtons);
                    SendMessage(sbhWnd, SB_SETTEXT, 4, str);
                    if ((lastX != pkt.pkX || \
                         lastY != pkt.pkY || \
                         lastPressure != pkt.pkNormalPressure || \
                         lastCursor != pkt.pkCursor || \
                         lastButtons != pkt.pkButtons) && \
                        pdTransferMutex && pdTabletData) {
                        WaitForSingleObject(pdTransferMutex, INFINITE);
                        pdTabletData->eventBuffer[pdTabletData->nEvents].x = pkt.pkX;
                        pdTabletData->eventBuffer[pdTabletData->nEvents].y = 1023 - pkt.pkY;
                        pdTabletData->eventBuffer[pdTabletData->nEvents].pressure = pkt.pkNormalPressure;
                        pdTabletData->eventBuffer[pdTabletData->nEvents].orientation = pkt.pkCursor;
                        pdTabletData->eventBuffer[pdTabletData->nEvents].buttons = pkt.pkButtons;
                        if (pdTabletData->nEvents < MAXEVENTS - 1) {
                            pdTabletData->nEvents++;
                        }
                        ReleaseMutex(pdTransferMutex);
                    }
                    lastX = pkt.pkX;
                    lastY = pkt.pkY;
                    lastPressure = pkt.pkNormalPressure;
                    lastCursor = pkt.pkCursor;
                    lastButtons = pkt.pkButtons;
                }
            }
            break;
        case WM_MOUSEMOVE:
        case WM_LBUTTONDOWN:
        case WM_LBUTTONDBLCLK:
        case WM_LBUTTONUP:
        case WM_MBUTTONDOWN:
        case WM_MBUTTONUP:
        case WM_MBUTTONDBLCLK:
        case WM_RBUTTONDOWN:
        case WM_RBUTTONUP:
        case WM_RBUTTONDBLCLK:
            break;
        case WM_COMMAND:
            fHandled = FALSE;
            break;

        case WT_INFOCHANGE:        /* IF some info item changed */
            PrsInit();        /* update the pressure mapping state vars. */
            break;
        case WM_TIMER:
            SetTimer(hWnd, 1, 500, NULL);
            break;
        case WM_DESTROY:
            if (hTab)
                WTClose(hTab);
#ifdef USE_X_LIB
            _UnlinkWintab();
#endif
            PostQuitMessage(0);
            break;
        default:
            fHandled = FALSE;
            break;
    }
    if (fHandled)
        return (lResult);
    else
        return (DefWindowProc(hWnd, message, wParam, lParam));
}


